MdTopReader
Date: 2019-10-22

org.jmol.adapter.readers.more

## Class MdTopReader

- java.lang.Object
- - org.jmol.adapter.smarter.AtomSetCollectionReader
  - - org.jmol.adapter.readers.more.ForceFieldReader
    - - org.jmol.adapter.readers.more.MdTopReader

- All Implemented Interfaces:
    javajs.api.GenericLineReader

      public class MdTopReader
      extends ForceFieldReader

  A reader for Amber Molecular Dynamics topology files -- requires subsequent COORD "xxxx.mdcrd" file

  PDB note: Note that topology format does not include chain designations, chain terminator, chain designator, or element symbol. Chains based on numbering reset just labeled A B C D .... Z a b c d .... z Element symbols based on reasoned guess and properties of hetero groups In principal we could use average atomic mass.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private int` | `ac`
    `private java.lang.String[]` | `atomTypes`
    `(package private) java.lang.String[]` | `group3s`
    `private int` | `nAtoms`

    - ### Fields inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addedData, addedDataKey, addVibrations, allowPDBFilter, ANGSTROMS_PER_BOHR, applySymmetryToBonds, asc, baseAtomIndex, binaryDoc, bsFilter, bsModels, calculationType, continuing, debugging, desiredModelNumber, desiredSpaceGroupIndex, desiredVibrationNumber, doApplySymmetry, doCentralize, doCheckUnitCell, doConvertToFractional, doPackUnitCell, doProcessLines, doReadMolecularOrbitals, dssr, fileName, fileOffset, filePath, fileScaling, fillRange, filter, filterHetero, fixJavaFloat, forcePacked, getHeader, haveAtomFilter, haveModel, havePartialChargeFilter, htParams, ignoreFileSpaceGroupName, ignoreFileSymmetryOperators, ignoreFileUnitCell, ignoreStructure, iHaveFractionalCoordinates, iHaveSymmetryOperators, iHaveUnitCell, isBinary, isConcatenated, isDSSP1, isFinalized, isMolecular, isPrimitive, isSequential, isTrajectory, latticeCells, latticeScaling, latticeType, line, lstNCS, matUnitCellOrientation, modDim, modelNumber, ms, mustFinalizeModelSet, next, out, packingError, prevline, primitiveToCrystal, ptLine, ptSupercell, reader, readerName, requiresBSFilter, reverseModels, rotateHexCell, sgName, stateScriptVersionInt, strSupercell, symmetry, templateAtomCount, thisBiomolecule, trajectorySteps, unitCellOffset, unitCellParams, useAltNames, useFileModelNumbers, validation, vibrationNumber, vibsFractional, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MdTopReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `checkLine()`
    `protected void` | `finalizeSubclassReader()` optional reader-specific method run first.
    `private void` | `getAtomNames()`
    `private void` | `getAtomTypes()`
    `private void` | `getCharges()`
    `private java.lang.String[]` | `getDataBlock()`
    `private void` | `getMasses()`
    `private void` | `getPointers()`
    `private void` | `getResidueLabels()`
    `private void` | `getResiduePointers()`
    `protected void` | `initializeReader()`

    - ### Methods inherited from class org.jmol.adapter.readers.more.ForceFieldReader

      `deducePdbElementSymbol, getElementSymbol, setUserAtomTypes`

    - ### Methods inherited from class org.jmol.adapter.smarter.AtomSetCollectionReader

      `addAtomXYZSymName, addExplicitLatticeVector, addJmolScript, addSites, addSiteScript, appendLoadNote, appendUunitCellInfo, applySymmetryAndSetTrajectory, applySymTrajASCR, checkCurrentLineForScript, checkFilterKey, checkLastModel, checkLineForScript, clearUnitCell, cloneLastAtomSet, discardLinesUntilBlank, discardLinesUntilContains, discardLinesUntilContains2, discardLinesUntilNonBlank, discardLinesUntilStartsWith, discardPreviousAtoms, doGetModel, doGetVibration, doPreSymmetry, fill3x3, fillDataBlock, fillDataBlockFixed, fillFloatArray, fillFrequencyData, filterAtom, filterReject, finalizeMOData, finalizeModelSet, finalizeReaderASCR, finalizeSubclassSymmetry, forceSymmetry, fractionalizeCoordinates, getElementSymbol, getFilter, getFortranFormatLengths, getInterface, getNewSymmetry, getStrings, getSymmetry, getTokens, getTokensFloat, initializeSymmetry, initializeSymmetryOptions, initializeTrajectoryFile, isLastModel, newAtomSet, parseFloat, parseFloatRange, parseFloatStr, parseInt, parseIntAt, parseIntRange, parseIntStr, parseToken, parseTokenNext, parseTokenRange, parseTokenStr, processBinaryDocument, processDOM, rd, read3Vectors, readDataObject, readLines, readNextLine, rejectAtomName, RL, set2D, setAtomCoord, setAtomCoordScaled, setAtomCoordTokens, setAtomCoordXYZ, setChainID, setElementAndIsotope, setFilter, setFilterAtomTypeStr, setFractionalCoordinates, setIsPDB, setLoadNote, setModelPDB, setSpaceGroupName, setSymmetryOperator, setTransform, setUnitCell, setUnitCellItem, setup, setupASCR`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### nAtoms

          private int nAtoms

    - #### ac

          private int ac

    - #### atomTypes

          private java.lang.String[] atomTypes

    - #### group3s

          java.lang.String[] group3s

  - ### Constructor Detail

    - #### MdTopReader

          public MdTopReader()

  - ### Method Detail

    - #### initializeReader

          protected void initializeReader()
                                   throws java.lang.Exception

      Overrides:
        `initializeReader` in class `AtomSetCollectionReader`
      Throws:
        `java.lang.Exception`

    - #### checkLine

          protected boolean checkLine()
                               throws java.lang.Exception

      Overrides:
        `checkLine` in class `AtomSetCollectionReader`
      Returns:
        true if need to read new line
      Throws:
        `java.lang.Exception`

    - #### finalizeSubclassReader

          protected void finalizeSubclassReader()
                                         throws java.lang.Exception

      Description copied from class: `AtomSetCollectionReader`
      optional reader-specific method run first.
      Overrides:
        `finalizeSubclassReader` in class `AtomSetCollectionReader`
      Throws:
        `java.lang.Exception`

    - #### getDataBlock

          private java.lang.String[] getDataBlock()
                                           throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getPointers

          private void getPointers()
                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getAtomTypes

          private void getAtomTypes()
                             throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getCharges

          private void getCharges()
                           throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getResiduePointers

          private void getResiduePointers()
                                   throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getResidueLabels

          private void getResidueLabels()
                                 throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getAtomNames

          private void getAtomNames()
                             throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getMasses

          private void getMasses()
                          throws java.lang.Exception

      Throws:
        `java.lang.Exception`